package model

type DistributeFeedFormulaRequest struct {
	PastureId int64          `json:"pasture_id"`
	Body      []*FeedFormula `json:"body"`
}

type PastureResponse struct {
	Code int32       `json:"code"`
	Msg  string      `json:"msg"`
	Data interface{} `json:"data"`
}

type DashboardAccuracyRequest struct {
	CattleParentCategoryId int32  `json:"cattle_parent_category_id,omitempty"`
	FeedFormulaId          int32  `json:"feed_formula_id"`
	StartDate              string `json:"start_date"`
	EndDate                string `json:"end_date"`
	PastureId              int32  `json:"pasture_id"`
}

type PastureAnalysisAccuracyResponse struct {
	Code int32                        `json:"code"`
	Msg  string                       `json:"msg"`
	Data *PastureAnalysisAccuracyData `json:"data"`
}

type PastureAnalysisAccuracyData struct {
	MixedFodderAccurateRatio    []*PastureAnalysisAccuracyDataValue `json:"mixed_fodder_accurate_ratio"`    // 混料准确率
	MixedFodderCorrectRatio     []*PastureAnalysisAccuracyDataValue `json:"mixed_fodder_correct_ratio"`     // 混料正确率
	SprinkleFodderAccurateRatio []*PastureAnalysisAccuracyDataValue `json:"sprinkle_fodder_accurate_ratio"` // 撒料准确率
	SprinkleFodderCorrectRatio  []*PastureAnalysisAccuracyDataValue `json:"sprinkle_fodder_correct_ratio"`  // 撒料正确率
}

type PastureAnalysisAccuracyDataValue struct {
	DayTime string  `json:"day_time"`
	Ratio   float64 `json:"ratio"`
}
